from random import *

seed(777)

def write_test(n, test_str):
    filename = "{:0>2}".format(n)
    filename += ".in"
    f = open(filename, "w")
    f.write(test_str)

class TestGen:
    def __init__(self, start_n):
        self.testno = start_n

    def next_test(self, test_str):
        write_test(self.testno, test_str)
        self.testno += 1

def rand_tree(n):
    parent = [randint(0, i - 1) for i in range(1, n)]
    perm = [i for i in range(1, n)]
    shuffle(perm)
    perm = [0] + perm
    parent = [0] + parent

    newp = parent
    for i in range(n):
        newp[perm[i]] = perm[parent[i]]

    g = [[] for i in range(n)]
    for i in range(1, n):
        g[newp[i]].append(i)

    return g

def set_children(v, tree, controls):
    for i in range(tree):
        controls[i]


# def set_controls(v, tree, controls):
#     sa = 0
#     sb = 0
#     # controls.append([1, 1000000, len(tree[v])])
#     print v
#     for u in tree[v]:
#         set_controls1(u, tree, controls)
#         # sa += controls[u][0]
#         # sb += controls[b][1]
#     # controls = [()] * n
#     # tree = rand_tree(n)


def set_controls1(v, tree, controls):
    # sa = 0
    # sb = 0
    controls.append([1, 1000000, len(tree[v])])
    for u in tree[v]:
        set_controls1(u, tree, controls)
        # sa += controls[u][0]
        # sb += controls[b][1]
    # controls = [()] * n
    # tree = rand_tree(n)

def simple_tree(n):
    tree = rand_tree(n)
    res = []
    set_controls1(0, tree, res)
    return res



def controls_str(ctrls):
    return str(len(ctrls)) + "\n" + "\n".join(map(lambda x: " ".join(map(str, x)), ctrls))


def simple_chain(l, r, n):
    res = [[l, r, 1] for i in range(n)]
    res[-1][2] = 0
    return res

def simple_chain2(n):
    res = [[1000, 2000, 1]] + [[1, 1500, 1] for i in range(n - 1)]
    res[-1][2] = 0
    return res

def simple_chain3(a, b, n):
    res = [[a + i, b + i, 1] for i in range(n)]
    res[-1][2] = 0
    return res

def simple_star(n):
    res = [[n - 1, n, n - 1]] + [[1, 1, 0] for i in range(n - 1)]
    return res

def simple_star2(n):
    res = [[n + n // 3, 2 * n, n - 1]] + [[1, 2, 0] for i in range(n - 1)]
    return res

def simple_star3(n):
    res = [[n + n // 3, 2 * n - n // 3, n - 1]] + [[1, 2, 0] for i in range(n - 1)]
    return res

maxn = 1000

gen = TestGen(16)

gen.next_test(controls_str(simple_chain(1, 1, maxn)))
gen.next_test(controls_str(simple_chain(1, maxn, maxn)))
gen.next_test(controls_str(simple_chain(125, 555, maxn)))
gen.next_test(controls_str(simple_chain2(maxn)))
gen.next_test(controls_str(simple_chain3(1000, 2000, maxn)))
gen.next_test(controls_str(simple_chain3(1000, 1100, maxn)))
gen.next_test(controls_str(simple_chain3(1000, 10000, maxn)))

gen.next_test(controls_str(simple_star(maxn)))
gen.next_test(controls_str(simple_star2(maxn)))
gen.next_test(controls_str(simple_star3(maxn)))

gen.next_test(controls_str(simple_tree(maxn)))
gen.next_test(controls_str(simple_tree(maxn)))
# print(controls_str(simple_tree(10)))
