#include <sstream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <string>
#include <cassert>
#include <ctime>
#include <map>
#include <math.h>
#include <cstdio>
#include <set>
#include <deque>
#include <memory.h>
#include <queue>

#pragma comment(linker, "/STACK:64000000")
typedef long long ll;

using namespace std;

const int MAXK = -1;
const int MAXN = 1024;

int n;
int a[MAXN], b[MAXN], c[MAXN];
int sz;
vector<int> e[MAXN];
bool ok[MAXN];

void dfs1(int v) {
	cin >> a[v] >> b[v];
	int ch = 0;
	cin >> ch;

	int mn = 0;
	int mx = 0;
	ok[v] = 1;
	for (int i = 0; i < ch; i++) {
		int to = sz++;
		e[v].push_back(to);
		dfs1(to);
		mn += a[to];
		mx += b[to];
		ok[v] &= ok[to];
	}
	if (ch) {
		a[v] = max(a[v], mn);
		b[v] = min(b[v], mx);
	}
	ok[v] &= a[v] <= b[v];
}

void dfs2(int v, int x) {
	c[v] = x;
	for (int to : e[v]) x -= a[to];
	for (int to : e[v]) {
		int k = min(x, b[to] - a[to]);
		dfs2(to, a[to] + k);
		x -= k;
	}
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	while (cin >> n) {
		sz = 0;
		dfs1(sz++);
		if (!ok[0]) cout << -1 << endl;
		else {
			dfs2(0, a[0]);
			for (int i = 0; i < n; i++) cout << c[i] << " \n"[i + 1 == n];
		}
	}

	return 0;
}
